use AnyDBM_File;
use Fcntl;
require "./script/system/lock.cgi";
&DBM_OPEN($DBM_NO,"NO");
@NOLIST = values %NO;
for(@NOLIST)
{
	&error("ANZX") if $_ eq $ENV{'REMOTE_ADDR'};
}

sub decode{
	require 'jcode.pl';
	if ($ENV{'REQUEST_METHOD'} eq "POST"){
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else { $buffer = $ENV{'QUERY_STRING'}; }
	@pairs = split(/&/,$buffer);
	foreach $pair (@pairs)
	{
		($i_name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		if(!$Kanri_mode)
		{
			$value = &string_decode($value);
		}
		# J}ϊipJ}SpJ}֕ϊj
		# jcode.pl𗘗pĕR[hϊ
		&error("formG[") if  length($form{$i_name}) > 5000;
		&jcode'convert(*value,'sjis');
		$form{$i_name} .= (defined $form{$i_name}) ? ",$value" : $value;  
	}
	$mode = $form{'mode'};
}
sub string_decode
{
	$_[0] =~ s/</&lt;/g;
	$_[0] =~ s/>/&gt;/g;
	$_[0] =~ s/\n//g;
	$_[0] =~ s/\s//g;
	$_[0] =~ s/\,//g;
	$_[0] =~ s/=//g;
	$_[0] =~ s/&//g;
	$_[0] =~ s/"/h/g;
	$_[0] =~ s/'/f/g;
	$_[0] =~ s/\./D/g;
	return $_[0];
}

sub header
{
print "Content-type: text/html\n";
if($ENV{'HTTP_ACCEPT_ENCODING'}=~/gzip/ && $S_ZIP)
{
	print "Content-encoding: gzip\n\n";
	open(STDOUT,"| /bin/gzip -1 -c");
}
print << "EOF";

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS" />
<meta http-equiv="Pragma" content="no-cache" />
<meta http-equiv="Expires" content="-1" />
<link rel="stylesheet" type="text/css" href="./script/css/deste.css" />
$_[0]
<title>$S_N_Title</title>
</head>
<body>
EOF
}
sub footer
{
print << "EOF";
<br />
<p align="center">DestE ver $S_Prg_Ver Copyright (c) 2004-2006 <a href="http://www.mimuret.org" target="_blank" >Mimuret Laboratory</a>. All rights reserved.</p>
<p align="center">$S_N_Logo</p>
</body></html>
EOF
}
sub DBM_OPEN
{
	my %NOTE;
	my $HASH   = $_[1];
	my $ARRAY  = $HASH . "_VALUES" if $_[2];
	&Lock("SH");
	tie (%NOTE,"AnyDBM_File","$_[0]",O_RDWR | O_CREAT,0644);
	%$HASH=%NOTE;
	untie %NOTE;
	&UnLock;
	@$ARRAY  = split(/\s/,$$HASH{"$_[2]"}) if $_[2];
}

sub ITEM_CONVERT
{
	&Read_Weapon_Data;
	$it="$_[0]L_ITEM";
	$it2="$_[0]L_ITEMS";
	my(@item) = split(/!/,$_[1]);
	my(@items) = split(/,/,$WEAPON_LIST{$item[0]});
	$items[1] = int($items[1] * (1 + $item[1] / $S_Weapon_Need_Ex / $S_Weapon_Lv_Max / 5));
	@$it = @item;
	@$it2 = @items;
}
sub Read_Weapon_Data
{
	return 0 if($Read_SW{'Read_Weapon_Data'});
	require "$S_Hash_data";
	$Read_SW{'Read_Weapon_Data'} = 1;
}
sub Set_Item
{
	return "$_[0]!$_[1]!$_[2]!$_[3]!$_[4]!$_[5]!$_[6]";
}
sub repair
{
	my $value=$_[0]."_VALUES";
	my ($times,$dammy) = split(/\!/,$$value[1]);
	my $val = time - $times;
	$$value[17]+=$val*$S_R_EN;
	$$value[17]= $$value[18] if ($$value[17] > $$value[18]);
	$$value[15]+=$val*$S_R_HP;
	if ($$value[15] > $$value[16])
	{
		$$value[15] = $$value[16];
		$$value[25] = 0;
	}
}
sub repair_cl
{
	my $value = $_[0];
	($yhp,$mhp,$mdata)		= split(/!/,$value->[11]);
	($mat,$mdf,$mme,$name)	= split(/!/,$value->[12]);	$yhp += int((time - $mdata) * $S_R_HP);
	$yhp = $mhp if $yhp > $mhp;
}
# KPKQ
sub Rank
{
	my$op=int $_[0]/10;
	$op = 0 if ($op < 0 || $_[2] eq "");
	$op = ($op < 21) ? $op:21;
	$op = 22 if $_[1] == 1;
	my$Class_Source = "<span class=\"class_$op\">$S_Class[$op]</span>";
	if($_[1] == -1)
	{
		$Class_Source .= "<span class=\"class_22\">ij</span>";
	}
	return $Class_Source;
}
sub Status_Convert
{

	if($_[1] eq "s")
	{
		my($op) =int($_[0] / 5);
		$op = 10 if $op > 10;
		return "<span class=\"class_$S_Rank[$op]\">$S_Rank[$op]</span>";
	}
	elsif($_[1] eq "j")
	{
		my($op) =int($_[0] / 100);
		$op = 10 if $op > 10;
		return "<span class=\"class_$S_Rank[$op]\">$S_Rank[$op]</span>";
	}
	elsif($_[1] eq "c")
	{
		return "<span style=\"color:$S_Character_c[$_[0]];\">$S_Character[$_[0]]</span>";
	}
	elsif($_[1] eq "t")
	{
		return "<span style=\"color:$S_Type_c[$_[0]];\">$S_Type[$_[0]]</span>";
	}

}
sub get_time
{
		$_[0] or $_[0]=time;
		($sec,$min,$hour,$day,$mon,$year) = localtime($_[0]);
		$year +=1900;
		$mon++;
		if($hour < 10){
			$hour = "$hour";
		}else{
			$hour = "$hour";
		}
		if($min < 10){
			$hour = "$hour";
		}else{
			$min = "$min";
		}
		return "$mon$day ($hour:$min)";
	}

sub error
{
	local($msg) = @_;
	&header;
	print <<"	EOF";
	<script type="text/javascript">
	<!--
		alert('@_');
	-->
	</script>
	<form method="post" target="Main" name="Form" />
	<hr>
	<p align="center">G[</p>
	<p align="center">@_</p>
	<p align="center">$form{'mode'}</p>
	<p align="center"><a href="./$S_Main_File" target="_top">Topɖ߂</a></p>
	<p align="center"><input type="submit" class="input" value="Statusɖ߂" /></p>
	<hr>
	<input type="hidden" name="pname" value="$form{'pname'}" />
	<input type="hidden" name="pass" value="$form{'pass'}" />
	<input type="hidden" name="mode" value="Status"/>
	</form>
	EOF
	&footer;
	exit;
}
sub Confirm
{
	print <<"EOF";
		<script language="JavaScript">
		function $_[0]()
		{
			return confirm('$_[1]');
		}
		</script>
EOF
}
#################################################################################
sub set_cookie{

	my @gmt = gmtime(time + 7*24*60*60);
	$gmt[0] = sprintf("%02d", $gmt[0]);	$gmt[1] = sprintf("%02d", $gmt[1]);
	$gmt[2] = sprintf("%02d", $gmt[2]);	$gmt[3] = sprintf("%02d", $gmt[3]);	$gmt[5] += 1900;
	$gmt[4] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$gmt[4]];
	$gmt[6] = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday')[$gmt[6]];
	my $date_gmt = "$gmt[6], $gmt[3]\-$gmt[4]\-$gmt[5] $gmt[2]:$gmt[1]:$gmt[0] GMT";
	$cookie{'mission'} = $form{'mission'} if $form{'mission'};
	$cook = "pname:$form{'pname'},pass:$form{'pass'},mission:$cookie{'mission'}";
	print "Set-Cookie: DestE=$cook; expires=$date_gmt;\n";

}
sub get_cookie{
	return 0 if($Read_SW{'get_cookie'});
	@pair = split(/\s/, $ENV{'HTTP_COOKIE'});
	foreach (@pair)
	 {
	 	my($skey,$svalue) = split(/;/, $_);
	 	my($key, $value) = split(/=/, $skey);
		$DUMMY{$key} = $value;
	}
	@pairs = split(/,/, $DUMMY{'DestE'});
	foreach (@pairs)
	{
		my($key, $value) = split(/:/, $_);
		$cookie{$key} = $value;
	}
	$Read_SW{'get_cookie'} = 1;
}

sub DBM_WRITE
{
	&Lock;
	dbmopen(%HASH,$_[0],0666);
	$HASH{$_[1]} = $_[2];
	dbmclose(%HASH);
	&UnLock;
}
sub DBM_DELETE
{
	&Lock;
	dbmopen(%HASH,$_[0],0666);
	delete $HASH{$_[1]};
	dbmclose(%HASH);
	&UnLock;
}
sub	check
{
	&error("sANZXłB") if($mode eq "check");
	my($name,$pass)=($form{'pname'},$form{'pass'});
	($name,$pass)=($_[0],$_[1]) if $_[0];
	$passs = crypt ($pass,"dest");
	&DBM_OPEN($DBM_PL,"PL",$name);
	&error("݂ȂIDłB$name:$pass") if !@PL_VALUES;
	&error("passv܂:$name:$pass") if ($PL_VALUES[2] ne $passs);
	&set_cookie;
}


1;
